Index: codes/icosagcm/trunk/arch/arch-X64_TITANE.env
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE.env	(revision 27)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE.env	(revision 27)
@@ -0,0 +1,7 @@
+module unload netcdf
+module unload hdf5
+export HDF5_INC_DIR=$WORKDIR/hdf5/include
+export HDF5_LIB_DIR=$WORKDIR/hdf5/lib
+
+export NETCDF_INC_DIR=$WORKDIR/netcdf4/include
+export NETCDF_LIB_DIR=$WORKDIR/netcdf4/lib
Index: codes/icosagcm/trunk/arch/arch-X64_TITANE.fcm
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE.fcm	(revision 26)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE.fcm	(revision 27)
@@ -4,12 +4,12 @@
 %MAKE                gmake
 %FPP_FLAGS           -P -traditional
-%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM FFT_MKL
-%BASE_FFLAGS        -openmp  -i4 -r8 -automatic -align all -I${MKLROOT}/include -I$NETCDF_INC_DIR
-%PROD_FFLAGS         -O3
+%FPP_DEF             KEY_NONE 
+%BASE_FFLAGS         -i4 -r8 -automatic -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -O3 -openmp
 %DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
-%DEBUG_FFLAGS        -p -g -traceback
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
 %MPI_FFLAGS
 %OMP_FFLAGS          -openmp
-%BASE_LD             -openmp -i4 -r8 -automatic $MKL_LIBS -L$NETCDF_LIB_DIR -lnetcdf -lnetcdff
+%BASE_LD             -openmp -i4 -r8 -automatic $MKL_LIBS
 %MPI_LD
 %OMP_LD              -openmp
Index: codes/icosagcm/trunk/arch/arch-X64_TITANE.path
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE.path	(revision 26)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE.path	(revision 27)
@@ -1,11 +1,11 @@
-NETCDF_LIBDIR="$NETCDF_LIB_DIR -lnetcdff"
-NETCDF_INCDIR=$NETCDF_INC_DIR
-IOIPSL_INCDIR=$LMDGCM/../../lib
-IOIPSL_LIBDIR=$LMDGCM/../../lib
-ORCH_INCDIR=$LMDGCM/../../lib
-ORCH_LIBDIR=$LMDGCM/../../lib
-OASIS_INCDIR=$LMDGCM/../../prism/X64/build/lib/psmile.$couple
-OASIS_LIBDIR=$LMDGCM/../../prism/X64/lib
-INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
-INCA_INCDIR=$LMDGCM/../INCA3/config/lib
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
 
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
Index: codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.env
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.env	(revision 27)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.env	(revision 27)
@@ -0,0 +1,4 @@
+module unload netcdf
+module unload hdf5
+module load netcdf/3.6.3
+module load hdf5
Index: codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.fcm
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.fcm	(revision 27)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.fcm	(revision 27)
@@ -0,0 +1,15 @@
+%COMPILER            ifort
+%LINK                ifort
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE 
+%BASE_FFLAGS         -i4 -r8 -automatic -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -O3 -openmp
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -openmp -i4 -r8 -automatic $MKL_LIBS
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.path
===================================================================
--- codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.path	(revision 27)
+++ codes/icosagcm/trunk/arch/arch-X64_TITANE_SEQ.path	(revision 27)
@@ -0,0 +1,11 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"