Index: codes/icosagcm/trunk/param_sets/dcmip2012/test2/earth_const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test2/earth_const.def	(revision 65)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test2/earth_const.def	(revision 65)
@@ -0,0 +1,17 @@
+#planetary radius : real (default=37122E6)
+radius=6.37122E6
+
+# gravity : real (default=9.80616)
+g=9.80616
+
+#planetary rotation rate (default=7.292E-5)
+omega=7.292E-5
+
+# kappa=Rd/cpp (default=0.2857143)
+kappa=0.2857143
+  
+# Heat capacity at constant pressure real (default=1004.70885)
+cpp=1004.5
+
+# Reference pressure : real (default=101325.)
+preff=100000.
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test2/run21.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test2/run21.def	(revision 65)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test2/run21.def	(revision 65)
@@ -0,0 +1,125 @@
+INCLUDEDEF=earth_const.def
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor=500.
+
+# ------------------------------- Mesh ---------------------------------
+
+# Number of subdivision on a main triangle (nbp) : integer (default=40)
+nbp=60
+
+# sub splitting of main rhombus : integer (default=1)
+nsplit_i=1
+nsplit_j=1
+
+# Number of vertical layer (llm) : integer (default=19)
+llm=60
+
+# disvert : vertical discretisation : string (default='std') : std, ncar, ncar30l
+disvert=ncar
+
+# ncar_dz : model layer thickness in meters: real (default=400) 
+# used if disvert=ncar
+ncar_dz=500.
+
+# optim_it : mesh optimisation : number of iteration : integer (default=0)
+optim_it=0
+
+# ------------------------------------------------------------------------
+
+
+
+# ---------------------------------- Misc --------------------------------
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=1
+
+# timestep : real (default=90s for nbp=40)
+dt = 60.
+
+# number of timestep (default 100)
+# itaumax = 10000
+
+# run length : real (default=dt*itaumax)
+run_length=3.6e6
+
+# output field period : integer (default none)
+write_period=50000
+
+# etat0 : initial state : string (default=jablonowsky06) : 
+# jablonowsky06, academic, ncar
+etat0=dcmip2_schaer_noshear
+
+# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
+caldyn=gcm
+
+# ----------------------------------------------------------------------
+
+
+
+
+# ------------------------------ Dynamics --------------------------------
+
+# scheme type : string ( default='adam_bashforth') euler, leapfrog, leapfrog_matsuno, adam_bashforth)
+scheme = adam_bashforth
+
+# matsuno period : integer ( default=5)
+matsuno_period = 5
+
+# guided_type : string (default=none) : none, ncar
+guided_type=none
+
+# ----------------------------------------------------------------------
+
+
+
+# ------------------------------ Dissipation ---------------------------
+
+# dissipation time graddiv : real (default=5000)
+tau_graddiv = 1800
+
+# number of iteration for graddiv : integer (default=1)
+ nitergdiv = 1
+
+
+# dissipation time nxgradrot (default=5000)
+tau_gradrot = 1800
+
+# number of iteration for nxgradrot : integer (default=1)
+nitergrot=2
+
+
+# dissipation time divgrad (theta) (default=5000)
+tau_divgrad=1800
+
+# number of iteration for divgrad : integer (default=1)
+niterdivgrad=2
+
+# -----------------------------------------------------------------------
+
+
+
+
+# -------------------- parameters for NCAR test cases ------------------------
+
+# NCAR advection test, initial tracer : string ( default='cos_bell')
+# const, slotted_cyl, cos_bell, dbl_cos_bell_q1, dbl_cos_bell_q2, complement, hadley
+ncar_adv_shape=complement
+
+# NCAR advection test, wind field : string (default='deform') : solid, deform, hadley
+ncar_adv_wind=deform
+
+# ncar_T0 : reference temperature for NCAR test cases : real (default=300) 
+# also used by disvert if disvert=ncar
+ncar_T0=300
+
+# ncar_p0 : reference pressure for NCAR test cases : real (default=1e5) 
+# also used by disvert if disvert=ncar
+ncar_p0=1e5
+
+# ncar_disvert_c : exponent for B(eta) : integer (default=1)
+# used by disvert if disvert=ncar
+
+ncar_disvert_c=1
+
+#-----------------------------------------------------------------------