Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/earth_const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/earth_const.def	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/earth_const.def	(revision 88)
@@ -0,0 +1,20 @@
+#planetary radius : real (default=37122E6)
+radius=6.37122E6
+
+# gravity : real (default=9.80616)
+g=9.80616
+
+#planetary rotation rate (default=7.292E-5)
+omega=7.292E-5
+
+# kappa=Rd/cpp (default=0.2857143)
+kappa=0.2857143
+  
+# Heat capacity at constant pressure real (default=1004.70885)
+cpp=1004.5
+
+# Reference pressure : real (default=101325.)
+preff=100000.
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor=1.
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/job_lynx
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/job_lynx	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/job_lynx	(revision 88)
@@ -0,0 +1,14 @@
+#!/bin/bash
+#PBS -N icosagcm              
+#PBS -q workshop                 
+#PBS -l mppwidth=60          
+##PBS -l mppnppn=12              
+#PBS -l walltime=00:30:00      
+#PBS -e icosagcm.out             
+#PBS -j eo                     
+#PBS -V                        
+cd $PBS_O_WORKDIR    
+
+export MPICH_MAX_SHORT_MSG_SIZE=1024
+	           
+aprun -n 60 ./icosa_gcm.exe > out         
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/run.def	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-0/run.def	(revision 88)
@@ -0,0 +1,134 @@
+INCLUDEDEF=earth_const.def
+
+# ------------------------------- Mesh ---------------------------------
+
+# Number of subdivision on a main triangle (nbp) : integer (default=40)
+nbp=80
+
+# sub splitting of main rhombus : integer (default=1)
+nsplit_i=2
+nsplit_j=3
+
+# Number of vertical layer (llm) : integer (default=19)
+llm=30
+
+# disvert : vertical discretisation : string (default='std') : std, ncar, ncar30l
+disvert=ncarl30
+
+# ncar_dz : model layer thickness in meters: real (default=400) 
+# used if disvert=ncar
+ncar_dz=1000.
+
+# optim_it : mesh optimisation : number of iteration : integer (default=0)
+optim_it=0
+
+# ------------------------------------------------------------------------
+
+
+
+# ---------------------------------- Misc --------------------------------
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=2
+
+# timestep : real (default=90s)
+dt = 45.
+
+# number of timestep (default 100)
+# itaumax = 10000
+
+# run length : real (default=dt*itaumax)
+run_length=1296000
+
+# output field period : integer (default none)
+write_period=21600
+
+# etat0 : initial state : string (default=jablonowsky06) : 
+# jablonowsky06, academic, ncar
+etat0=dcmip4
+
+# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
+caldyn=gcm
+
+# ----------------------------------------------------------------------
+
+
+
+
+# ------------------------------ Dynamics --------------------------------
+
+# scheme type : string ( default='adam_bashforth') euler, leapfrog, leapfrog_matsuno, adam_bashforth)
+scheme = adam_bashforth
+
+# matsuno period : integer ( default=5)
+matsuno_period = 5
+
+# guided_type : string (default=none) : none, ncar
+guided_type=none
+
+# ----------------------------------------------------------------------
+
+
+
+# ------------------------------ Dissipation ---------------------------
+
+# dissipation time graddiv : real (default=5000)
+tau_graddiv = 1800
+
+# number of iteration for graddiv : integer (default=1)
+ nitergdiv = 1
+
+
+# dissipation time nxgradrot (default=5000)
+tau_gradrot = 1800
+
+# number of iteration for nxgradrot : integer (default=1)
+nitergrot=2
+
+
+# dissipation time divgrad (theta) (default=5000)
+tau_divgrad=1800
+
+# number of iteration for divgrad : integer (default=1)
+niterdivgrad=2
+
+# -----------------------------------------------------------------------
+
+
+# -------------------- physics ------------------------------------------
+
+# kind of physics : string : none, dcmip (default=none)
+physics=dcmip
+
+# testcase physics for dcmip : INTEGER : 1, 2 (default=1)
+dcmip_physics=1
+
+# -----------------------------------------------------------------------
+
+
+
+# -------------------- parameters for NCAR test cases ------------------------
+
+# NCAR advection test, initial tracer : string ( default='cos_bell')
+# const, slotted_cyl, cos_bell, dbl_cos_bell_q1, dbl_cos_bell_q2, complement, hadley
+ncar_adv_shape=cos_bell
+
+# NCAR advection test, wind field : string (default='deform') : solid, deform, hadley
+ncar_adv_wind=solid
+
+# ncar_T0 : reference temperature for NCAR test cases : real (default=300) 
+# also used by disvert if disvert=ncar
+ncar_T0=300
+
+# ncar_p0 : reference pressure for NCAR test cases : real (default=1e5) 
+# also used by disvert if disvert=ncar
+ncar_p0=1e5
+
+# ncar_disvert_c : exponent for B(eta) : integer (default=1)
+# used by disvert if disvert=ncar
+
+ncar_disvert_c=1
+
+# dcmip 4 testcase : integer (default=1) : 1, 2
+dcmip4_testcase=2
+#-----------------------------------------------------------------------
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/earth_const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/earth_const.def	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/earth_const.def	(revision 88)
@@ -0,0 +1,20 @@
+#planetary radius : real (default=37122E6)
+radius=6.37122E6
+
+# gravity : real (default=9.80616)
+g=9.80616
+
+#planetary rotation rate (default=7.292E-5)
+omega=7.292E-5
+
+# kappa=Rd/cpp (default=0.2857143)
+kappa=0.2857143
+  
+# Heat capacity at constant pressure real (default=1004.70885)
+cpp=1004.5
+
+# Reference pressure : real (default=101325.)
+preff=100000.
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor=1.
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/job_lynx
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/job_lynx	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/job_lynx	(revision 88)
@@ -0,0 +1,14 @@
+#!/bin/bash
+#PBS -N icosagcm              
+#PBS -q workshop                 
+#PBS -l mppwidth=160          
+##PBS -l mppnppn=12              
+#PBS -l walltime=00:30:00      
+#PBS -e icosagcm.out             
+#PBS -j eo                     
+#PBS -V                        
+cd $PBS_O_WORKDIR    
+
+export MPICH_MAX_SHORT_MSG_SIZE=1024
+	           
+aprun -n 160 ./icosa_gcm.exe > out         
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/run.def	(revision 88)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.2/test4.2-1/run.def	(revision 88)
@@ -0,0 +1,134 @@
+INCLUDEDEF=earth_const.def
+
+# ------------------------------- Mesh ---------------------------------
+
+# Number of subdivision on a main triangle (nbp) : integer (default=40)
+nbp=160
+
+# sub splitting of main rhombus : integer (default=1)
+nsplit_i=4
+nsplit_j=4
+
+# Number of vertical layer (llm) : integer (default=19)
+llm=30
+
+# disvert : vertical discretisation : string (default='std') : std, ncar, ncar30l
+disvert=ncarl30
+
+# ncar_dz : model layer thickness in meters: real (default=400) 
+# used if disvert=ncar
+ncar_dz=1000.
+
+# optim_it : mesh optimisation : number of iteration : integer (default=0)
+optim_it=0
+
+# ------------------------------------------------------------------------
+
+
+
+# ---------------------------------- Misc --------------------------------
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=2
+
+# timestep : real (default=90s)
+dt = 22.
+
+# number of timestep (default 100)
+# itaumax = 10000
+
+# run length : real (default=dt*itaumax)
+run_length=1296000
+
+# output field period : integer (default none)
+write_period=21600
+
+# etat0 : initial state : string (default=jablonowsky06) : 
+# jablonowsky06, academic, ncar
+etat0=dcmip4
+
+# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
+caldyn=gcm
+
+# ----------------------------------------------------------------------
+
+
+
+
+# ------------------------------ Dynamics --------------------------------
+
+# scheme type : string ( default='adam_bashforth') euler, leapfrog, leapfrog_matsuno, adam_bashforth)
+scheme = adam_bashforth
+
+# matsuno period : integer ( default=5)
+matsuno_period = 5
+
+# guided_type : string (default=none) : none, ncar
+guided_type=none
+
+# ----------------------------------------------------------------------
+
+
+
+# ------------------------------ Dissipation ---------------------------
+
+# dissipation time graddiv : real (default=5000)
+tau_graddiv = 900
+
+# number of iteration for graddiv : integer (default=1)
+ nitergdiv = 1
+
+
+# dissipation time nxgradrot (default=5000)
+tau_gradrot = 900
+
+# number of iteration for nxgradrot : integer (default=1)
+nitergrot=2
+
+
+# dissipation time divgrad (theta) (default=5000)
+tau_divgrad= 900
+
+# number of iteration for divgrad : integer (default=1)
+niterdivgrad=2
+
+# -----------------------------------------------------------------------
+
+
+# -------------------- physics ------------------------------------------
+
+# kind of physics : string : none, dcmip (default=none)
+physics=dcmip
+
+# testcase physics for dcmip : INTEGER : 1, 2 (default=1)
+dcmip_physics=1
+
+# -----------------------------------------------------------------------
+
+
+
+# -------------------- parameters for NCAR test cases ------------------------
+
+# NCAR advection test, initial tracer : string ( default='cos_bell')
+# const, slotted_cyl, cos_bell, dbl_cos_bell_q1, dbl_cos_bell_q2, complement, hadley
+ncar_adv_shape=cos_bell
+
+# NCAR advection test, wind field : string (default='deform') : solid, deform, hadley
+ncar_adv_wind=solid
+
+# ncar_T0 : reference temperature for NCAR test cases : real (default=300) 
+# also used by disvert if disvert=ncar
+ncar_T0=300
+
+# ncar_p0 : reference pressure for NCAR test cases : real (default=1e5) 
+# also used by disvert if disvert=ncar
+ncar_p0=1e5
+
+# ncar_disvert_c : exponent for B(eta) : integer (default=1)
+# used by disvert if disvert=ncar
+
+ncar_disvert_c=1
+
+# dcmip 4 testcase : integer (default=1) : 1, 2
+dcmip4_testcase=2
+#-----------------------------------------------------------------------